LeetCode 36 有效的数独

题目描述

有效的数独

请你判断一个 9 x 9 的数独是否有效。只需要 根据以下规则 ,验证已经填入的数字是否有效即可。

  1. 数字 1-9 在每一行只能出现一次。
  2. 数字 1-9 在每一列只能出现一次。
  3. 数字 1-9 在每一个以粗实线分隔的 3x3 宫内只能出现一次。(请参考示例图)

注意:

  • 一个有效的数独(部分已被填充)不一定是可解的。
  • 只需要根据以上规则,验证已经填入的数字是否有效即可。
  • 空白格用 '.' 表示。

示例 1:

复制代码
输入:board = 
[["5","3",".",".","7",".",".",".","."]
,["6",".",".","1","9","5",".",".","."]
,[".","9","8",".",".",".",".","6","."]
,["8",".",".",".","6",".",".",".","3"]
,["4",".",".","8",".","3",".",".","1"]
,["7",".",".",".","2",".",".",".","6"]
,[".","6",".",".",".",".","2","8","."]
,[".",".",".","4","1","9",".",".","5"]
,[".",".",".",".","8",".",".","7","9"]]
输出:true

示例 2:

复制代码
输入:board = 
[["8","3",".",".","7",".",".",".","."]
,["6",".",".","1","9","5",".",".","."]
,[".","9","8",".",".",".",".","6","."]
,["8",".",".",".","6",".",".",".","3"]
,["4",".",".","8",".","3",".",".","1"]
,["7",".",".",".","2",".",".",".","6"]
,[".","6",".",".",".",".","2","8","."]
,[".",".",".","4","1","9",".",".","5"]
,[".",".",".",".","8",".",".","7","9"]]
输出:false
解释:除了第一行的第一个数字从 5 改为 8 以外,空格内其他数字均与 示例1 相同。 但由于位于左上角的 3x3 宫内有两个 8 存在, 因此这个数独是无效的。

提示:

  • board.length == 9
  • board[i].length == 9
  • board[i][j] 是一位数字(1-9)或者 '.'

解法

有效的数独满足以下三个条件:

  • 同一个数字在每一行只能出现一次;
  • 同一个数字在每一列只能出现一次;
  • 同一个数字在每一个小九宫格只能出现一次。

可以使用哈希表记录每一行、每一列和每一个小九宫格中,每个数字出现的次数。只需要遍历数独一次,在遍历的过程中更新哈希表中的计数,并判断是否满足有效的数独的条件即可。

对于数独的第 i 行第 j 列的单元格,其中 0≤i,j<90,该单元格所在的行下标和列下标分别为 i 和 j,该单元格所在的小九宫格的行数和列数分别为 i/3和j/3,其中 0 <= i/3,j/3 < 3。

由于数独中的数字范围是 1 到 9,因此可以使用数组代替哈希表进行计数。

具体做法是,创建二维数组 rows 和 columns 分别记录数独的每一行和每一列中的每个数字的出现次数,创建三维数组 subboxes 记录数独的每一个小九宫格中的每个数字的出现次数,其中rows[i][index]、columns[j][index]和subboxes[i/3][j/3][index]分别表示数独的第 i 行第 j 列的单元格所在的行、列和小九宫格中,数字 index+1 出现的次数,

如果 board[i][j] 填入了数字 n,则将rows[i][n-1]和columns[j][n-1]和subboxes[i/3][j/3][n-1]各加 1。如果更新后的计数大于 1,则不符合有效的数独的条件,返回 false。

如果遍历结束之后没有出现计数大于 111 的情况,则符合有效的数独的条件,返回 true。

java代码:

java 复制代码
class Solution {
    public boolean isValidSudoku(char[][] board) {
        int[][] rows = new int[9][9];
        int[][] columns = new int[9][9];
        int[][][] subboxes = new int[3][3][9];

        for (int i = 0; i < 9; i++) {
            for (int j = 0; j < 9; j++) {
                char c = board[i][j];
                if (c != '.') {
                    // 计算数字为几
                    int index = c - '0' - 1;
                    // 分别对行、列和9宫格计数,对应数字 + 1
                    rows[i][index] += 1;
                    columns[j][index] += 1;
                    subboxes[i/3][j/3][index] += 1;
                    // 如果行、列和9宫格任何一个大于1了,返回false
                    if (rows[i][index] > 1 || columns[j][index] > 1 || subboxes[i/3][j/3][index] > 1) {
                        return false;
                    }
                }
            }
        }
        return true;
    }
}

复杂度

  • 时间复杂度:O(1),数独共有 81 个单元格,只需要对每个单元格遍历一次即可。
  • 空间复杂度:O(1),由于数独的大小固定,因此哈希表的空间也是固定的。
相关推荐
129Lab几秒前
BMS 核心算法:SOC 估算从安时积分到 LSTM-UKF 串级融合的 30 年演进(附 Python 实现)
python·算法·lstm·python3.11·bms·soc估算
kgkg2 分钟前
我通过逆向学到了douyin的美颜算法
算法
Xin7704 分钟前
LeetCode 230. 二叉搜索树中第 K 小的元素(迭代中序遍历 + 栈)
leetcode
anew___19 分钟前
《从零手写操作系统 (30):环境变量与进程上下文——export/unset与继承语义》
java·开发语言·网络·jvm·算法
垆边人似月.31 分钟前
城市连通性(200分 / 并查集)
数据结构·算法·图论
Gust of wind1 小时前
串与KMP模式匹配:存储结构、基本操作、next数组手算
c语言·数据结构·后端·算法
Navigator_Z1 小时前
LeetCode //C - 1283. Find the Smallest Divisor Given a Threshold
c语言·算法·leetcode
by209991 小时前
list:迭代器与资源管理实现的综合叙述(下)
数据结构·c++·笔记·list
啦啦啦啦啦zzzz1 小时前
一致性哈希
服务器·算法·哈希算法·c++20·分布式存储
我不会起名字3221 小时前
二叉树的遍历与二叉搜索树:把递归、迭代、还原树一次讲透
数据结构·leetcode·二叉树·二叉搜索树